#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <alloc.h>
#include <dos.h>
unsigned long uBound=0;
unsigned long MaxCost;
unsigned long NumCalls;
FILE *NAME;

//structure to keep number of columns,used for solution
struct SetCols {
   unsigned int ColumnNumber;
   struct SetCols *Next;
 };

//structure to keep number of rows,used for MSIR
struct SetRows {
   unsigned int Offset;
   struct SetRows *Next;
 };

//structure, where is kept linkt to set of columns included to solution
struct HeaderSol {
  unsigned int Cost;
  struct SetCols *SetC;//Link to set of columns
};

//structure, where is kept linkt to set of rows included to MSIR
struct HeaderSetRows {
   struct SetRows *RowsLink;
};

//structure where are kept row links an column links
struct CLink {
   struct CLink *Previous;
   struct CLink *Next;
   unsigned int ID;
   unsigned int Offset; //Offset to jump from one item to next
   unsigned int Cost;

   unsigned int NumberOf1;
   };

//Structure where is kept the matrix
struct CoveringMatrix {
  struct CLink *RowLink;  //Link to rows of matrix
  struct CLink *ColLink;  //Link to columns of matrix
  unsigned int Cost;
  unsigned int Dirty;
  unsigned int M;        //Dimensions of matrix
  unsigned int N;
  unsigned char *Mat;    //Array
};

void Release (struct CoveringMatrix * CM)
{ //Function to release allocated memory for structure keeping matrix
  struct CLink *Aux;
  struct CLink *Aux2;

  if ( CM->ColLink !=0 )
    {//First,delete all rows
     Aux=CM->ColLink->Next;
    delete (CM->ColLink);
     while ( Aux!=0 )
      {
	Aux2=Aux->Next;
	delete (Aux);
	Aux=Aux2;
      }
    }
  if ( CM->RowLink !=0 )
    {//then delete all columns
     Aux=CM->RowLink->Next;
     delete (CM->RowLink);
     while ( Aux!=0 )
      {
	Aux2=Aux->Next;
	delete (Aux);
	Aux=Aux2;
      }
    }
  delete (CM);//fillany delete header of structure
}

void Release ( struct HeaderSetRows *HSR )
{ //structure to release allocated memory for MSIR
  struct SetRows *Aux;
  struct SetRows *Aux2;

  if ( HSR->RowsLink !=0 )
   {//delete all row links
      Aux=HSR->RowsLink->Next;
      delete ( HSR->RowsLink );
      while ( Aux!=0 )
	 {
	    Aux2=Aux->Next;
	    delete (Aux);
	    Aux=Aux2;
	 }
   }
   delete ( HSR );//delete header
}

void Release ( struct HeaderSol *SolUCP )
{ //structure to release allocated memory for solution
  struct SetCols *Aux;
  struct SetCols *Aux2;

  if ( SolUCP->SetC !=0 )
   {//delete all column links
      Aux=SolUCP->SetC->Next;
      delete ( SolUCP->SetC );
      while ( Aux!=0 )
	 {
	    Aux2=Aux->Next;
	    delete (Aux);
	    Aux=Aux2;
	 }
   }
   delete ( SolUCP );//delete header
}

struct HeaderSol *Init ( void )
{//Structure to create empty header structure to keep solution
   struct HeaderSol *Solution;
   //first allocate memory
   Solution=new HeaderSol;
     if ( Solution==NULL)
       {
	printf ("Insufficient memory \n");
	exit(0);
       }
   //and set all antries to zero
   Solution->Cost=0;
   Solution->SetC=0;

  return Solution;
}

struct HeaderSetRows *InitSet ( void )
{//Structure to create empty header structure to keep rows of MSIR
   struct HeaderSetRows *Hlavicka;
   //first allocate memory
   Hlavicka=new HeaderSetRows;
     if ( Hlavicka==NULL)
       {
	printf ("Insufficient memory \n");
	exit(0);
       }
   //and set all antries to zero

   Hlavicka->RowsLink=0;
  return Hlavicka;
}

void AppendSolution (struct HeaderSol *Source,struct HeaderSol *Target )
{//function to apend partial solution to solution of UCP
  struct SetCols *Aux;

  //if there are no cols in solution of UCP
  if ( Target->SetC==0 ) Target->SetC=Source->SetC;
   else
     { //else connect to the end of link
       Aux=Target->SetC;
       while ( Aux->Next!=0 )
	 Aux=Aux->Next;
       Aux->Next=Source->SetC;
     }
  Target->Cost+=Source->Cost;
  delete (Source);//delete header of partial solution,it is no inter needed
}

void AddToSolution ( struct HeaderSol *SolutionUCP,struct CLink *Column )
{//Function to add column number to solution
     struct SetCols *Solution;
     struct SetCols *Aux;

     Solution=new SetCols;
     if ( Solution==NULL)
       {
	  printf ("Insufficient memory \n");
	  exit(0);
       }
     Solution->ColumnNumber=Column->ID;
     Solution->Next=0;

     if ( SolutionUCP->SetC==0 )
	{//if there are no entries in solution
	  SolutionUCP->SetC=Solution;
	  SolutionUCP->Cost=Column->Cost;
	}
      else
       {//else append it to the end od links
	 SolutionUCP->Cost+=Column->Cost;
	 Aux=SolutionUCP->SetC;
	 while ( Aux->Next!=0 )
	 Aux=Aux->Next;
	 Aux->Next=Solution;
       }
}

void AddToSetRows ( struct HeaderSetRows *HSR,int Offset )
{//Function to add row entry to set
     struct SetRows *RowToAdd;
     struct SetRows *Aux;

     RowToAdd=new SetRows;
     if ( RowToAdd==NULL)
       {
	  printf ("Insufficient memory \n");
	  exit(0);
       }
     RowToAdd->Offset=Offset;
     RowToAdd->Next=0;
     //if set is empty
     if ( HSR->RowsLink==0 )
	{
	  HSR->RowsLink=RowToAdd;
	}
      else
       {//else append to the end
	 Aux=HSR->RowsLink;
	 while ( Aux->Next!=0 )
	 Aux=Aux->Next;

	 Aux->Next=RowToAdd;
       }
}

void PrintSolution ( struct HeaderSol *SolutionUCP )
{
   struct SetCols *Aux;
//   int Cost=0;
   Aux=SolutionUCP->SetC;
   while (Aux!=0 )
     {
	fprintf(NAME,"%d ",Aux->ColumnNumber );
	printf("%d ",Aux->ColumnNumber );
//	Cost++;
	Aux=Aux->Next;
     }

  fprintf(NAME,"\nCost: %lu\n\n----------------------------\n",SolutionUCP->Cost);
  printf("\nCost: %lu\n\n----------------------------\n",SolutionUCP->Cost);
}

void RemoveColumn ( struct CoveringMatrix *CM, struct CLink *Entry )
{//remove column from covering matrix
  struct CLink *Aux;
  if ( CM->ColLink !=0 )
    {
	if ( Entry->Next != 0&&Entry->Previous!=0 )
	  {
	   Entry->Next->Previous=Entry->Previous;
	   Entry->Previous->Next=Entry->Next;
	  }
       else
	if ( Entry->Next!=0&&Entry->Previous==0	)
	  {
	   Entry->Next->Previous=0;
	   CM->ColLink=Entry->Next;
	  }
	else
	if ( Entry->Next == 0&&Entry->Previous!=0 )
	  {
	   Entry->Previous->Next=0;
	  }
	else
	if ( Entry->Next == 0&&Entry->Previous==0 )
	  {//if it is the only column in the matrix,all rows must be deleted
	   //to set the matrix empty
	   CM->ColLink=0;
	   while (CM->RowLink!=0)
	    {//release allocated memory for rows
	      Aux=CM->RowLink->Next;
	      delete (CM->RowLink);
	      CM->RowLink=0;
	      CM->RowLink=Aux;
	   }
	   CM->RowLink=0;

	  }
	CM->M--;//decrease dimension of matrix
	delete (Entry);//delete column
    }
}
void RemoveRow ( struct CoveringMatrix *CM, struct CLink *Entry )
{
  struct CLink *Aux;

  if ( CM->RowLink !=0 )
    {

	if ( Entry->Next != 0 &&Entry->Previous!=0 )
	  {
	   Entry->Next->Previous=Entry->Previous;
	   Entry->Previous->Next=Entry->Next;
	  }
       else
	if ( Entry->Next!=0 &&Entry->Previous==0	)
	  {
	   Entry->Next->Previous=0;
	   CM->RowLink=Entry->Next;
	  }
	else
	if ( Entry->Next == 0 &&Entry->Previous!=0 )
	  {
	   Entry->Previous->Next=0;
	  }
	else
	if ( Entry->Next == 0&&Entry->Previous==0 )
	  {
	   CM->RowLink=0;
	   while (CM->ColLink!=0)
	    {//if it is the only row in the matrix,all columns must be deleted
	   //to set the matrix empty
	      Aux=CM->ColLink->Next;
	      delete (CM->ColLink);
	      CM->ColLink=0;
	      CM->ColLink=Aux;
	   }
	   CM->ColLink=0;
	  }
	 delete (Entry);//delete row
	 CM->N--;//decrease dimension of matrix
    }
}

void RemoveColWithRows ( struct CLink * Column, struct CoveringMatrix *CM )
{//Function to remove column and all rows it covers
  struct CLink *RowLink;
  struct CLink *Aux;

  RowLink = CM->RowLink;
  while ( RowLink!=0)
   {
    if ( *(CM->Mat+RowLink->Offset+Column->Offset)==1 )
       {//if column intersect row,it will be deleted
	  Aux=RowLink->Next;
	  RemoveRow(CM,RowLink );
       }
     else Aux=RowLink->Next;
      RowLink=Aux;
   }//by deleting all rows int the matrix,all cols should be deleted too
   //if there is a column in the matrix,delete current column
   if ( CM->ColLink!=0 ) RemoveColumn ( CM,Column );
}

void RemoveColWithRowsClearContr ( struct CLink * Column, struct CoveringMatrix *CM )
{//Function to remove column and all rows it covers
  struct CLink *RowLink;
  struct CLink *Aux;
  struct CLink *ColAux;


  RowLink = CM->RowLink;
  while ( RowLink!=0)
   {
    if ( *(CM->Mat+RowLink->Offset+Column->Offset)==1 )
       {//if column intersect row,it will be deleted
	  ColAux = CM->ColLink;
	  while ( ColAux !=NULL )
	    {
	       if ( *(CM->Mat+RowLink->Offset+ColAux->Offset)==1 )
		 {
		    ColAux->NumberOf1=0;
		 }
	       ColAux=ColAux->Next;
	    }
	  Aux=RowLink->Next;
	  RemoveRow(CM,RowLink );
       }
     else Aux=RowLink->Next;
      RowLink=Aux;
   }//by deleting all rows int the matrix,all cols should be deleted too
   //if there is a column in the matrix,delete current column
   if ( CM->ColLink!=0 ) RemoveColumn ( CM,Column );
}


struct CoveringMatrix *Duplicate ( struct CoveringMatrix *CM)
{//Function to duplicate links to rows and cols of covering matrix
  struct CoveringMatrix *Copy;
  struct CLink *Rows;
  struct CLink *Columns;
  struct CLink *CMRowLink;
  struct CLink *CMColLink;

  CMRowLink=CM->RowLink;
  CMColLink=CM->ColLink;
  Copy=new CoveringMatrix;
  if ( Copy==NULL)
       {
	  printf ("Insufficient memory \n");
	  exit(0);
       }
//  Copy->NumCalls=NumCalls;
  Copy->Cost=CM->Cost;
  Copy->M=CM->M;
  Copy->N=CM->N;
  Copy->Mat=CM->Mat;//Sel all antries of created link to
  //values of link of original matrix
  Copy->ColLink=NULL;
  Copy->RowLink=NULL;

  if ( CM->RowLink!=NULL )
    {//if there are another entries,add it to duplicated matrix
      Copy->RowLink=new CLink;
      if ( Copy->RowLink==NULL)
       {
	  printf ("Insufficient memory \n");
	  exit(0);
       }
      Copy->RowLink->Previous=NULL;
      Copy->RowLink->Next=NULL;
      Copy->RowLink->Offset=CM->RowLink->Offset;
      Copy->RowLink->ID=CM->RowLink->ID;
      Copy->RowLink->NumberOf1=CM->RowLink->NumberOf1;
      Copy->RowLink->Cost=CM->RowLink->Cost;
      Rows=Copy->RowLink;
      CMRowLink=CM->RowLink->Next;


  while ( CMRowLink!=NULL )
   {
     Rows->Next=new CLink;
     if ( Rows->Next==NULL )
       {
	  printf ("Insufficient memory \n");
	  exit(0);
       }

     Rows->Next->Previous=Rows;
     Rows=Rows->Next;
     Rows->Offset=CMRowLink->Offset;
     Rows->ID=CMRowLink->ID;
     Rows->NumberOf1=CMRowLink->NumberOf1;
     Rows->Cost=CMRowLink->Cost;
//Sel all antries of created link to
  //values of link of original matrix
     Rows->Next=NULL;
     CMRowLink=CMRowLink->Next;
   }
  }

  if ( CM->ColLink!=NULL )
     {

       Copy->ColLink = new CLink;
       if ( Copy->ColLink==NULL)
       {
	  printf ("Insufficient memory \n");
	  exit(0);
       }

       Copy->ColLink->Previous=NULL;
       Copy->ColLink->Next=NULL;
       Copy->ColLink->Offset=CM->ColLink->Offset;
       Copy->ColLink->NumberOf1=CM->ColLink->NumberOf1;
       Copy->ColLink->Cost=CM->ColLink->Cost;
       Copy->ColLink->ID=CM->ColLink->ID;
       Columns=Copy->ColLink;
       CMColLink=CM->ColLink->Next;
//Sel all antries of created link to
  //values of link of original matrix

 while ( CMColLink!=NULL )
   {
     Columns->Next=new CLink;
     if ( Columns->Next==NULL )
       {
	  printf ("Insufficient memory \n");
	  exit(0);
       }

      Columns->Next->Previous=Columns;
     Columns=Columns->Next;

     Columns->Offset=CMColLink->Offset;
     Columns->ID=CMColLink->ID;
     Columns->NumberOf1=CMColLink->NumberOf1;
     Columns->Cost=CMColLink->Cost;

     Columns->Next=NULL;
     CMColLink=CMColLink->Next;
//Sel all antries of created link to
  //values of link of original matrix
    }
   }
  return Copy;
}


void Print ( struct CoveringMatrix *CM )
{//Print covering matrix to screen
  struct CLink *Columns;
  struct CLink *Rows;

  printf("\n    ");
    Columns=CM->ColLink;
    while ( Columns!=0)
    {
      printf ("%d ",Columns->Cost);
      Columns=Columns->Next;
    }
  printf("\n");
  Rows=CM->RowLink;
  while ( Rows!=0)
   {
    printf ( "%2d- ",Rows->ID);
    Columns=CM->ColLink;
    while ( Columns!=0)
    {
      printf ("%d ",*(CM->Mat+Rows->Offset+Columns->Offset));
      Columns=Columns->Next;
    }
    printf ("\n");
    Rows=Rows->Next;
   }
}


void CreateLinks ( struct CoveringMatrix *Cm )
{//Function to create row and column links of covering matrix
  unsigned int I,J;
  struct CLink *Columns;
  struct CLink *Rows;
  //Create row links
  Cm->RowLink = new CLink;
  if ( Cm->RowLink==NULL )
       {
	  printf ("Insufficient memory \n");
	  exit(0);
       }

  Cm->RowLink->Previous=0;
  Cm->RowLink->Offset=Cm->M;
  Cm->RowLink->ID=1;
  Cm->RowLink->NumberOf1=0;
  Rows=Cm->RowLink;
  for ( I=2;I<=Cm->N;I++)
   {
     Rows->Next=new CLink;
     if ( Rows->Next==NULL)
       {
	  printf ("Insufficient memory \n");
	  exit(0);
       }

     Rows->Next->Previous=Rows;
     Rows=Rows->Next;
     Rows->Offset=I*Cm->M*sizeof(char);
     Rows->ID=I;
     Rows->NumberOf1=0;
     Rows->Next=0;
   }
  //Create column links
  Cm->ColLink = new CLink;
  if ( Cm->ColLink==NULL)
       {
	  printf ("Insufficient memory \n");
	  exit(0);
       }

  Cm->ColLink->Previous=0;
  Cm->ColLink->Offset=0;
  Cm->ColLink->NumberOf1=0;
  Cm->ColLink->ID=1;
  Cm->ColLink->Cost=*(Cm->Mat);//cost of the column is kept at the beginning
				//of array
  uBound+=Cm->ColLink->Cost;//upper bound is computed here
  Columns=Cm->ColLink;

  for ( I=1;I<Cm->M;I++)
   {
     Columns->Next=new CLink;

     if ( Columns->Next==NULL)
       {
	  printf ("Insufficient memory \n");
	  exit(0);
       }

     Columns->Next->Previous=Columns;
     Columns=Columns->Next;
     Columns->Offset=I*sizeof(char);
     Columns->ID=I+1;
     Columns->NumberOf1=0;
     Columns->Cost=*(Cm->Mat+I);//cost of column
     uBound+=Columns->Cost;//increase upper bound
     Columns->Next=0;
   }
   uBound++;
   MaxCost=uBound;
}
struct CoveringMatrix *Load ( char *Filename )
{
  FILE *Name;
  unsigned int I,J;
  unsigned char Character;
  unsigned int Size;
  struct CoveringMatrix *Cm;

   Cm=new CoveringMatrix;
   if ( Cm==NULL )
       {
	  printf ("Insufficient memory \n");
	  exit(0);
       }
   Cm->Cost=0;
   Cm->M=0;
   Cm->N=0;
   Cm->Mat=NULL;

  if ( (Name=fopen(Filename, "rt"))==NULL)

     {
       printf ("Error opening file %s\n",Filename);
      exit(0);
     }
  Character=fgetc(Name);
  //first load dimensions of array to allocate memory
  while (Character>=48 && Character <= 57 )
    {
       Cm->M=Cm->M*10+Character-48;
       Character=fgetc(Name);
    }
  Character=fgetc(Name);
  while (Character>=48 && Character <= 57 )
    {
       Cm->N=Cm->N*10+Character-48;
       Character=fgetc(Name);
    }
  //compute the size to allocate,N+1 since costs of columns will be stored
  //at the beginning of array
   Size=(Cm->M*(Cm->N+1))*sizeof(char);
  Cm->Mat=new unsigned char [Size];
  if ( Cm->Mat==0 )

    {
	printf("Insufficient memory");
	exit(0);

    }
 //Load array
 for ( J=0;J<=Cm->N;J++)
  {
  for ( I=0;I<Cm->M;I++ )
   {
      *(Cm->Mat+I+J*Cm->M)=fgetc(Name)-48;
     Character=fgetc(Name);
     while (Character!=' ')
       {
	 *(Cm->Mat+I+J*Cm->M)*=10;
	 *(Cm->Mat+I+J*Cm->M)+=Character-48;
         fgetc(Name);
       }//space

   }
  fgetc(Name); //Enter
  }
  fclose(Name);
  CreateLinks ( Cm);
  return Cm;

}

void R_Dominance ( struct CoveringMatrix *CM,struct HeaderSol *SolutionUCP )
{//reduce the matrix by row dominance
  int Dominance;
  struct CLink *RowLink;
  struct CLink *Aux;
  struct CLink *ColLink;
  struct CLink *EssentialColumn;
  struct CLink *ComparedRow;
  int Dirty=0;
  unsigned int NumberOf1;
  unsigned char *ComparedRowOffset;
  unsigned char *OtherRowsOffset;

  ComparedRow=CM->RowLink;


  while ( ComparedRow != 0 )  //Row to compare
   {
      ComparedRowOffset=CM->Mat+ComparedRow->Offset;
      RowLink=CM->RowLink;  //
		//Other rows are compared,looking for dominance
      while ( RowLink!=0 )
	{
	  Dominance=0;
	  OtherRowsOffset=CM->Mat+RowLink->Offset;
	  ColLink=CM->ColLink;
	  NumberOf1=0;
	  EssentialColumn=NULL;
	  while ( ColLink!=0 )
	   {

	     if ( *(ComparedRowOffset+ColLink->Offset)==1 )
	      {
	      if ( *(OtherRowsOffset+ColLink->Offset)==1 )
	      {   //if ComparedRow has ones at the same position as the second,domitates
		if ( Dominance!=-1 ) Dominance=1;
	      }
	      else  { Dominance=-1; }//dominance failed
	      EssentialColumn=ColLink;
	      NumberOf1++;
	     }
	    ColLink=ColLink->Next;
	   }
	  if (Dominance==1&&RowLink->ID!=ComparedRow->ID)
	    {//if copare row with itself,it cannot be removed
		Aux=RowLink->Next;
		RemoveRow (CM,RowLink );
		Dirty = 1;
	    }
	  else Aux=RowLink->Next;
	 RowLink=Aux;

      }
     if ( NumberOf1==1)
     {//if row is covered by only one column,it is esential column,
      //will be added to solution and removed from matrix with
      //rows it covers
	AddToSolution ( SolutionUCP,EssentialColumn);
	Aux=ComparedRow->Next;
	RemoveColWithRows(EssentialColumn,CM);
	Dirty = 1;
	ComparedRow=Aux;
     }
   else ComparedRow=ComparedRow->Next;
  }
CM->Dirty=Dirty;
}

void S_Dominance ( struct CoveringMatrix *CM)
{//reduce the matrix by column dominance
  int Dominance;
  int Dirty=0;
  struct CLink *RowLink;
  struct CLink *Aux;
  struct CLink *ColLink;
  struct CLink *ComparedCol;
  unsigned char *ComparedColOffset;
  unsigned char *OtherColOffset;

  ComparedCol=CM->ColLink;

  while ( ComparedCol != 0 )  //Column to compare
   {
      ComparedColOffset=CM->Mat+ComparedCol->Offset;

      ColLink=CM->ColLink;
      while ( ColLink!=0 )
	{
	  Aux=ColLink->Next;
	  OtherColOffset=CM->Mat+ColLink->Offset;
	  if ( ColLink->ID!=ComparedCol->ID )
	  {//To disable compare column with itself
	  Dominance=0;
	  RowLink=CM->RowLink;
	  while ( RowLink!=0 )
	   {
	    if ( *(OtherColOffset+RowLink->Offset)==1 )
	      if ( *(ComparedColOffset+RowLink->Offset)==1 )
	      {   //if ComparedCol has ones at the same position as second col
		  //it has less ones than second column,will be removed
		Dominance=1;
	      }
	      else  { Dominance=0; break; }//dominance failed
	    RowLink=RowLink->Next;
	   }
	  if (Dominance==1)  //column will be renoved here
	    {
		if ( ColLink->Cost >= ComparedCol->Cost ) //remove/add comment to keep
							  //column with less cost than copared col
							  //in matrix
		  {
		    RemoveColumn (CM,ColLink );
		    Dirty = 1;
		  }
	    }
	  }
	 ColLink=Aux;
	}

   ComparedCol=ComparedCol->Next;
  }
   CM->Dirty=Dirty;

//  return CM;
}

void FindNumberOf1 ( struct CoveringMatrix *CM )
{//function to find number of ones in rows and columns
 int One;
 struct CLink *Columns;
 struct CLink *Rows;

 Columns=CM->ColLink;
 while ( Columns!=0)
  {
    Columns->NumberOf1=0;
    Columns=Columns->Next;
  }
  Rows=CM->RowLink;
  while ( Rows!=0)
   {
     Rows->NumberOf1=0;
     Rows=Rows->Next;
   }
 Columns=CM->ColLink;
 while ( Columns!=0)
  {
    One=0;
    Rows=CM->RowLink;
  while ( Rows!=0)
   {
    One = *(CM->Mat+Columns->Offset+Rows->Offset);
    if (One )
     {
       Rows->NumberOf1+=One;
       Columns->NumberOf1+=One;
     }
    Rows=Rows->Next;
   }
  Columns=Columns->Next;
  }
}

void RecomputeNumberOf1 ( struct CoveringMatrix *CM )
{//function to find number of ones in rows and columns
 int One;
 struct CLink *Columns;
 struct CLink *Rows;

 Columns=CM->ColLink;
 while ( Columns!=0)
  {
  if ( Columns->NumberOf1 ==0 )
   {
   One=0;
   Rows=CM->RowLink;
   while ( Rows!=0)
    {
     One = *(CM->Mat+Columns->Offset+Rows->Offset);
     if (One )
      {
	Columns->NumberOf1+=One;
      }
     Rows=Rows->Next;
    }
    }
   Columns=Columns->Next;

  }
}


void SolveDominance ( struct CoveringMatrix *CM,struct HeaderSol *SolutionUCP )
{ //Reduce matrix with dominance relations
int ColDom=0;
 if ( CM->ColLink !=0 )
  {

   CM->Dirty=1;
//Dominance will be solved as long as any change has been made
   while (CM->Dirty)
    {
      R_Dominance(CM,SolutionUCP);
	if ( CM->Dirty==1||ColDom==0 )
	 {
	  CM->Dirty=0;
	  S_Dominance(CM);
	  ColDom=1;
	 }
    }
 }
}

void NaturalHeuristic ( struct CoveringMatrix *CM,struct HeaderSol *SolUCP,int Dominance=0 )
{ //This heuristic consist in choosing columns which covers the largest
  //number of rows
 struct CLink *ColLink;
 struct CLink *SelectedColumn;
 NumCalls++;
 while ( CM->ColLink !=0 )
  {
   if ( Dominance ) SolveDominance(CM,SolUCP);
    if ( CM->ColLink !=0 )
    {
    FindNumberOf1(CM);
    ColLink=CM->ColLink;
    SelectedColumn=CM->ColLink;
    while ( ColLink!=0 )
      {//find column with largest number of ones
	  if ( ColLink->NumberOf1==SelectedColumn->NumberOf1 )
	    {
 		if ( ColLink->Cost<SelectedColumn->Cost ) SelectedColumn=ColLink;
		 else {
		   randomize();
	           if ( random (2) ) SelectedColumn=ColLink;
 		}
	    }
	  if ( ColLink->NumberOf1>SelectedColumn->NumberOf1 )
	  SelectedColumn=ColLink;
	  ColLink=ColLink->Next;
      }
    if ( SelectedColumn->NumberOf1 !=0 )
     {
      AddToSolution ( SolUCP,SelectedColumn );
     }
      RemoveColWithRows ( SelectedColumn,CM );
    }
   }


 }



void Choose ( struct CoveringMatrix *CM )
{//Evaluates columns according to number covered rows
  //with respect to "quality" of covering
 int One;
 struct CLink *ColLink;
 struct CLink *Rows;
 struct CLink *Sloupce2;

 ColLink=CM->ColLink;
 RecomputeNumberOf1(CM);
 while ( ColLink!=0)
  {
  ColLink->NumberOf1=0;
  One=0;
  Rows=CM->RowLink;
  while ( Rows!=0)
   {
    One = *(CM->Mat+ColLink->Offset+Rows->Offset);
    if (One ) {
       ColLink->NumberOf1+=CM->M-Rows->NumberOf1;
     }
    Rows=Rows->Next;
   }
  ColLink=ColLink->Next;
 }
}

void ContribAddHeuristic ( struct CoveringMatrix *CM,struct HeaderSol *SolUCP,int Dominance=0  )
{ //Select column with most ones in rows with few ones
 struct CLink *ColLink;
 struct CLink *SelectedColumn;
 NumCalls++;
 while ( CM->ColLink !=0 )
  {
    if ( Dominance ) SolveDominance (CM,SolUCP);
   if ( CM->ColLink !=0 )
    {

    Choose(CM);

    ColLink=CM->ColLink;
    SelectedColumn=CM->ColLink;
    while ( ColLink!=0 )
      {
	  if ( ColLink->NumberOf1==SelectedColumn->NumberOf1 )
	    {
 		if ( ColLink->Cost<SelectedColumn->Cost ) SelectedColumn=ColLink;
		 else {
		   randomize();
		   if ( random (2) ) SelectedColumn=ColLink;
 		}
	    }
	  if ( ColLink->NumberOf1>SelectedColumn->NumberOf1 )
	  SelectedColumn=ColLink;
	  ColLink=ColLink->Next;
      }
     {
      AddToSolution ( SolUCP,SelectedColumn );
     }
      RemoveColWithRowsClearContr ( SelectedColumn,CM );
    }
   }

}




unsigned int FindMSIRLLB ( struct CoveringMatrix *CM,unsigned int MSIR,struct HeaderSetRows *SetMSIR )
{//Function to find Maximal Set of Independent Rows
  struct CLink *Aux1;
  struct CLink *Aux2;
  struct CLink *RowWithMin1;
  struct CLink *Column;
  unsigned int MinCost=0;
  int Nezavisly;

  while ( CM->RowLink!=0 )
  {
  Aux1=CM->RowLink;
  Aux2=CM->RowLink->Next;
  FindNumberOf1 (CM);
  RowWithMin1=CM->RowLink;
  while (Aux2!=0 )
    {  //The less ones row has,the greater chance to be independent
      //select row with minimum ones
      if ( Aux2->NumberOf1 < RowWithMin1->NumberOf1 )
	RowWithMin1=Aux2;
      Aux2=Aux2->Next;
    }

  while (Aux1!=0 )
    {
    if ( Aux1!=RowWithMin1 )
    {
     Column=CM->ColLink;
     Nezavisly=0;
     while ( Column!=0 )
      {
       if ( *( CM->Mat+Aux1->Offset+Column->Offset ) ==1 )
	 if ( *( CM->Mat+RowWithMin1->Offset+Column->Offset ) ==0 )
	   {
	     Nezavisly=1;
	   }
	 else { Nezavisly=0;break; }
       Column=Column->Next;
      }
      if ( Nezavisly )
       {
	 Aux1=Aux1->Next;
       }
      else
	{
	  Aux2=Aux1->Next;
	  RemoveRow ( CM,Aux1 );
	  Aux1=Aux2;
	}
     }
     else {
	Aux1=Aux1->Next;  //To disable compare row with itself
       }
    }
  AddToSetRows ( SetMSIR,RowWithMin1->Offset );
  Aux1=CM->ColLink;
  while ( Aux1!=NULL)
   {
     if ( *(CM->Mat+RowWithMin1->Offset+Aux1->Offset) )
       {
	 if ( !MinCost ) MinCost=Aux1->Cost;
	   else if ( Aux1->Cost<MinCost ) MinCost=Aux1->Cost;
       }
     Aux1=Aux1->Next;
   }
  MSIR+=MinCost;
  RemoveRow ( CM,RowWithMin1 );
//  if ( CM->ColLink!=0 ) MSIR=FindMSIRLLB ( CM,MSIR,SetMSIR );
 }
// else return MSIR; //If matrix is empty
 return MSIR; //else independent row is found,increase MSIR
}

unsigned int FindMSIR ( struct CoveringMatrix *CM,unsigned int MSIR )
{//Function to find Number of MSIR
  struct CLink *Aux1;
  struct CLink *Aux2;
  struct CLink *RowWithMin1;


  struct CLink *Column;
  int Independent;
  unsigned int MinCost=0;
  if ( CM->RowLink!=0 )
  {
  Aux1=CM->RowLink;
  Aux2=CM->RowLink->Next;
  FindNumberOf1 (CM);
  RowWithMin1=CM->RowLink;
  while (Aux2!=0 )
    { //The less ones row has,the greater chance to be independent
      //select row with minimum ones
      if ( Aux2->NumberOf1 < RowWithMin1->NumberOf1 )
	RowWithMin1=Aux2;
      Aux2=Aux2->Next;
    }

  Independent=0;
  while (Aux1!=0 )
    {
    if ( Aux1!=RowWithMin1 )
    {
     Column=CM->ColLink;
     while ( Column!=0 )
      {//Find all dependent rows and remove them from matrix
       if ( *( CM->Mat+Aux1->Offset+Column->Offset ) ==1 )
	 if ( *( CM->Mat+RowWithMin1->Offset+Column->Offset ) ==0 )
	   {
	     Independent=1;
	   }
	 else { Independent=0;break; }
       Column=Column->Next;
      }
      if ( Independent )
       {
	 Aux1=Aux1->Next;
       }
      else
	{
	  Aux2=Aux1->Next;
	  RemoveRow ( CM,Aux1 );
	  Aux1=Aux2;
	}
     }
     else Aux1=Aux1->Next;  //To disable compare row with itself
    }
  Aux1=CM->ColLink;
  while ( Aux1!=NULL)
   {
     if ( *(CM->Mat+RowWithMin1->Offset+Aux1->Offset) )
       {
	 if ( !MinCost ) MinCost=Aux1->Cost;
	   else if ( Aux1->Cost<MinCost ) MinCost=Aux1->Cost;
       }
     Aux1=Aux1->Next;
   }
  MSIR+=MinCost;

  RemoveRow ( CM,RowWithMin1 );
  MSIR=FindMSIR ( CM,MSIR );
 }
 return MSIR; //else independent row is found,increase MSIR
}

void RemoveColumnNotMSIR ( CoveringMatrix *CM, HeaderSetRows *SetMSIR,unsigned int MSIR )
{//This function removes columns that do not intersect MSIR
  struct SetRows *Aux;
  struct CLink *ColLink;
  struct CLink *AuxSloupec;
  int NotIntersect;

  ColLink=CM->ColLink;
  Aux=SetMSIR->RowsLink;
  while ( ColLink != 0 )
    {
//     if ( CM->
     if ( ( uBound - ( CM->Cost+MSIR)) <= ColLink->Cost  )

      {
       NotIntersect=1;
       Aux=SetMSIR->RowsLink;
       while ( Aux!=0 )
	 {
	    //Test if column intersect row
	    if ( *(CM->Mat+Aux->Offset+ColLink->Offset) )
	      NotIntersect=0;
	    Aux=Aux->Next;
	 }
       if ( NotIntersect )
	 {
	    AuxSloupec=ColLink->Next;
	    RemoveColumn ( CM,ColLink );
	    ColLink=AuxSloupec;
	 }
       else ColLink=ColLink->Next;
      }
     else ColLink=ColLink->Next;
    }
}


unsigned int BAB ( struct CoveringMatrix *CM,struct HeaderSol *SolUCP  )
{//Ordinary Branch and Bound,only prunes branch if cost(path) >= uBound
   struct CLink *SelectedColumn;
   struct CoveringMatrix *CopyCM2;
   struct HeaderSol *SolUCP2;
   struct HeaderSol *SolUCP1;
   struct HeaderSol *SolUCP3;

 if ( CM->ColLink!=0 )
  {
   NumCalls++;
   SolUCP3=Init();//Solution given by essential columns
   SolveDominance(CM,SolUCP3);
   CM->Cost+=SolUCP3->Cost;

   if ( CM->ColLink!=0 )
    {
     SolUCP1=Init();//Solution given by first call B&B
     CopyCM2=Duplicate (CM);
     SelectedColumn=CM->ColLink;
     //First,add selected column to solution
     AddToSolution ( SolUCP1,SelectedColumn);
     CM->Cost+=SolUCP1->Cost;
     RemoveColWithRows ( SelectedColumn,CM ); //Remove it from matrix
					      //and continue branching
     if ( ( CM->Cost ) < uBound )//Condition to stop branching
      {
	if ( BAB(CM,SolUCP1)==1 ) SolUCP1->Cost=MaxCost;
      }
     else
       {
	 SolUCP1->Cost=MaxCost;
       }
     //second,do not add selected column to solution
     RemoveColumn ( CopyCM2,CopyCM2->ColLink);//remove it from matrix
					//,and continue branching
     SolUCP2=Init();
     if ( CopyCM2->Cost < uBound )
       {
	 if ( BAB(CopyCM2,SolUCP2)==1 )SolUCP2->Cost=MaxCost;
       }
     else
       {
	 SolUCP2->Cost=MaxCost;
       }
     Release (CopyCM2);//release memory used for duplicated matrix

     if ( SolUCP1->Cost < SolUCP2->Cost )//Solution 1 was succesfull
	   {
	      Release (SolUCP2);
	      AppendSolution ( SolUCP1,SolUCP3 );
	      AppendSolution (SolUCP3,SolUCP );
	      return 0;
	   }
	 else
	   {
	      if ( SolUCP2->Cost!=MaxCost )//Solution 2 was succesfull
		{
		  Release (SolUCP1);
		  AppendSolution ( SolUCP2,SolUCP3 );
		  AppendSolution ( SolUCP3,SolUCP );
		  return 0;
	       }
	     else
	       { //No solution was succesfull,return with error
		  Release (SolUCP1);
		  Release (SolUCP2);
		  Release (SolUCP3);
		  return 1;
	       }
	   }
    }
  else
    {
      if ( CM->Cost<uBound )
	{
	  printf ( "\nFound solution with cost %d\n",CM->Cost);
	  uBound=CM->Cost;
	  AppendSolution ( SolUCP3,SolUCP );
	  return 0;
	}
      else  {
       Release ( SolUCP3 );//Solution has greater cost than previously found
       return 1;
      }
    }
  }
  return 0;
}

unsigned int BABLLB ( struct CoveringMatrix *CM,struct HeaderSol *SolUCP  )
{//Branch and Bound with Limit Lower Bound computation
   struct CLink *SelectedColumn;
   struct CoveringMatrix *CopyCM2;
   struct CoveringMatrix *CopyCMForMSIR;
   struct HeaderSol *SolUCP2;
   struct HeaderSol *SolUCP1;
   struct HeaderSol *SolUCP3;
   struct HeaderSetRows *SetMSIR;
   unsigned int MSIR=0;

 if ( CM->ColLink!=0 )
  {
   NumCalls++;
   SolUCP3=Init();//Solution given by essential columns
   SolveDominance(CM,SolUCP3);
   CM->Cost+=SolUCP3->Cost;

   if ( CM->ColLink!=0 )
    {
     SolUCP1=Init();//Solution given by first call B&B
     CopyCM2=Duplicate (CM);
     SelectedColumn=CM->ColLink;

     //First,add selected column to solution
     AddToSolution ( SolUCP1,SelectedColumn);
     CM->Cost+=SolUCP1->Cost; //Remove it from matrix
			      //and continue branching
     RemoveColWithRows ( SelectedColumn,CM );
     CopyCMForMSIR=Duplicate(CM);//Duplicate matrix for MSIR computation
     SetMSIR=InitSet();//Init structure to store MSIR
     MSIR=FindMSIRLLB(CopyCMForMSIR,MSIR,SetMSIR);
     delete(CopyCMForMSIR);
//     if ( ( uBound - ( CM->Cost+MSIR)) == 1  )
      {//LLB may be applied when uBound - {|path to node|+lBound } == 1
//	CopyCMForMSIR=Duplicate(CM);
//	//Remove columns that do not intersect MSIR
//	RemoveColumnNotMSIR ( CopyCMForMSIR,SetMSIR,MSIR);
	RemoveColumnNotMSIR ( CM,SetMSIR,MSIR);
	MSIR=0;
	CopyCMForMSIR=Duplicate(CM);

	//Compute new MSIR
	MSIR=FindMSIRLLB(CopyCMForMSIR,MSIR,SetMSIR);
        delete(CopyCMForMSIR);
      }
     if ( ( CM->Cost+MSIR ) < uBound )
      {
	if ( BABLLB(CM,SolUCP1)==1 ) SolUCP1->Cost=MaxCost;
      }
     else
       {
	 SolUCP1->Cost=MaxCost;
       }

     //second,do not add selected column to solution
     //Remove it from matrix
     //and continue branching
     RemoveColumn ( CopyCM2,CopyCM2->ColLink);
     MSIR=0;
     CopyCMForMSIR=Duplicate(CopyCM2);
     Release (SetMSIR);
     SetMSIR=InitSet();
     MSIR=FindMSIRLLB(CopyCMForMSIR,MSIR,SetMSIR);
     delete(CopyCMForMSIR);
//     if ( ( uBound - ( CopyCM2->Cost+MSIR)) == 1  )
      {//the same as described above
//	CopyCMForMSIR=Duplicate(CopyCM2);
//	RemoveColumnNotMSIR ( CopyCMForMSIR,SetMSIR,MSIR);
	RemoveColumnNotMSIR ( CopyCM2,SetMSIR,MSIR);

	MSIR=0;
	CopyCMForMSIR=Duplicate(CopyCM2);
	MSIR=FindMSIRLLB(CopyCMForMSIR,MSIR,SetMSIR);
        delete(CopyCMForMSIR);
      }
     SolUCP2=Init();
     if ( CopyCM2->Cost+MSIR < uBound )
       {
	 if ( BABLLB(CopyCM2,SolUCP2)==1 )SolUCP2->Cost=MaxCost;
       }
     else
       {
	 SolUCP2->Cost=MaxCost;
       }
     Release (SetMSIR);
     Release (CopyCM2);

     if ( SolUCP1->Cost < SolUCP2->Cost )//Solution 1 was succesfull
	   {
	      Release (SolUCP2);
	      AppendSolution ( SolUCP1,SolUCP3 );
	      AppendSolution (SolUCP3,SolUCP );
	      return 0;
	   }
	 else
	   {
	      if ( SolUCP2->Cost!=MaxCost )//Solution 2 was succesfull
		{
		  Release (SolUCP1);
		  AppendSolution ( SolUCP2,SolUCP3 );
		  AppendSolution ( SolUCP3,SolUCP );
		  return 0;
	       }
	     else
	       {//No solution was succesfull
		  Release (SolUCP1);
		  Release (SolUCP2);
		  Release (SolUCP3);
		  return 1;
	       }
	   }
    }
  else
    {
      if ( CM->Cost<uBound )
	{
	  printf ( "\nFound solution with cost %d\n",CM->Cost);
	  uBound=CM->Cost;
	  AppendSolution ( SolUCP3,SolUCP );
	  return 0;
	}
      else
	{//Solution has greater cost than previously found
       Release ( SolUCP3 );
       return 1;
      }
    }
  }
  return 0;
}

unsigned int BABMSIR ( struct CoveringMatrix *CM,struct HeaderSol *SolUCP  )
{//Branch and Bound with MSIR computation
   struct CLink *SelectedColumn;
   struct CoveringMatrix *CopyCM2;
   struct CoveringMatrix *CopyCMForMSIR;
   struct HeaderSol *SolUCP2;
   struct HeaderSol *SolUCP1;
   struct HeaderSol *SolUCP3;
   unsigned int MSIR=0;

 if ( CM->ColLink!=0 )
  {
   NumCalls++;
   SolUCP3=Init();
   SolveDominance(CM,SolUCP3);
   CM->Cost+=SolUCP3->Cost;

   if ( CM->ColLink!=0 )
    {
     SolUCP1=Init();
     CopyCM2=Duplicate (CM);
     //first,add selected column to solution
     SelectedColumn=CM->ColLink;
     AddToSolution ( SolUCP1,SelectedColumn);
     CM->Cost+=SolUCP1->Cost;
     //Remove it from matrix
     //and continue branching
     RemoveColWithRows ( SelectedColumn,CM );

     CopyCMForMSIR=Duplicate(CM);
     MSIR=FindMSIR(CopyCMForMSIR,MSIR);

     if ( ( CM->Cost+MSIR ) < uBound )
      {
	if ( BABMSIR(CM,SolUCP1)==1 ) SolUCP1->Cost=MaxCost;
      }
     else
       {
	 SolUCP1->Cost=MaxCost;
       }

     //second,do not add selected column to solution
     //Remove it from matrix
     //and continue branching
     RemoveColumn ( CopyCM2,CopyCM2->ColLink);
     MSIR=0;
     CopyCMForMSIR=Duplicate(CopyCM2);
     MSIR=FindMSIR(CopyCMForMSIR,MSIR);
     SolUCP2=Init();

     if ( CopyCM2->Cost+MSIR < uBound )
       {
	 if ( BABMSIR(CopyCM2,SolUCP2)==1 )SolUCP2->Cost=MaxCost;
       }
     else
       {
	 SolUCP2->Cost=MaxCost;
       }
     Release (CopyCM2);

     if ( SolUCP1->Cost < SolUCP2->Cost )//Solution 1 was succesfull
	   {
	      Release (SolUCP2);
	      AppendSolution ( SolUCP1,SolUCP3 );
	      AppendSolution (SolUCP3,SolUCP );
	      return 0;
	   }
	 else
	   {
	      if ( SolUCP2->Cost!=MaxCost )//Solution 2 was succesfull
		{
		  Release (SolUCP1);
		  AppendSolution ( SolUCP2,SolUCP3 );
		  AppendSolution ( SolUCP3,SolUCP );
		  return 0;
	       }
	     else
	       {//No solution was succesfull
		  Release (SolUCP1);
		  Release (SolUCP2);
		  Release (SolUCP3);
		  return 1;
	       }
	   }
    }
  else
    {
      if ( CM->Cost<uBound )
	{
	  printf ( "\nFound solution with cost %d\n",CM->Cost);
	  uBound=CM->Cost;
	  AppendSolution ( SolUCP3,SolUCP );
	  return 0;
	}
      else
	{//Solution has greater cost than previously found
       Release ( SolUCP3 );
       return 1;
      }
    }
  }
  return 0;
}


struct time RunTime ( struct time StartTime,struct time StopTime )
{
  struct time Result;
  long double Time1=0;
  long double Time2=0;
  if (StopTime.ti_hour<StartTime.ti_hour) StopTime.ti_hour+=24;
  Time1=StopTime.ti_hour*360000+StopTime.ti_min*6000+StopTime.ti_sec*100+StopTime.ti_hund;
  Time2=StartTime.ti_hour*360000+StartTime.ti_min*6000+StartTime.ti_sec*100+StartTime.ti_hund;
  Time1-=Time2;

  Result.ti_hour=Time1/360000;
  Time1-=Result.ti_hour*360000;
  Result.ti_min=Time1/6000;
  Time1-=Result.ti_min*6000;
  Result.ti_sec=Time1/100;
  Time1-=Result.ti_sec*100;
  Result.ti_hund=Time1;
  return Result;
}


float MatrixDensity ( struct CoveringMatrix *CM )
{
  float NumberOf1=0;
  struct CLink *Column;
  struct CLink *Row;
  Column=CM->ColLink;
  while ( Column !=NULL)
   {
     Row=CM->RowLink;
     while ( Row!=NULL )
       {
	  NumberOf1+=*(CM->Mat+Column->Offset+Row->Offset);
	  Row=Row->Next;
       }
     Column=Column->Next;
   }
 return 1/((CM->M*CM->N)/NumberOf1);
}
void main ( int argc, char* argv[] )
{
   struct time StartTime,StopTime;
   struct CoveringMatrix *CM;
   struct CoveringMatrix *Cm;
   struct CoveringMatrix *CM2;
   struct CoveringMatrix *CM3;
   struct CoveringMatrix *CM4;
   struct CoveringMatrix *CM5;
   struct HeaderSol *SolutionUCP;
   int I,Dominance=0;
   char *OutputFile;
	unsigned int Hmin,Hmax,Hprum;
   double Time;
   clrscr();
   if ( argc == 1 )
     {
	printf ("Usage: cover.exe input_file [output_file]\n");
	exit(0);
     }

   Cm=Load (argv[1]);
   if ( argc == 3 ) OutputFile=argv[2];
      else OutputFile="Out.dat";
   if ( (NAME=fopen ( OutputFile,"wt"))==NULL)
      {
	printf("Cannot open output file %s \n");
	exit(0);
      }

   CM2=Duplicate(Cm);
   CM3=Duplicate(Cm);
   CM4=Duplicate(Cm);
   fprintf(NAME,"Filename: %s,Dimensions %dx%d, density of matrix %f\n\n",argv[1],Cm->M,Cm->N,MatrixDensity(Cm));
   printf("Filename: %s,Dimensions %dx%d, density of matrix %f\n\n",argv[1],Cm->M,Cm->N,MatrixDensity(Cm));
   fclose (NAME);








for (Dominance=0;Dominance<2;Dominance++)
 for ( I=0;I<1;I++)
  {
   CM=Duplicate(Cm);
   NAME=fopen ( OutputFile,"at");
   SolutionUCP=Init();
   NumCalls=0;
   uBound=MaxCost;
   printf ( "Solving by natural heuristic,dominance=%d \n",Dominance);
   fprintf (NAME, "Solving by natural heuristic,dominance=%d \n",Dominance);
   gettime(&StartTime);
   NaturalHeuristic( CM,SolutionUCP,Dominance);
   gettime(&StopTime);
   StopTime=RunTime(StartTime,StopTime);
   printf("Elapsed time : %2d:%02d:%02d.%02d\n",
       StopTime.ti_hour, StopTime.ti_min, StopTime.ti_sec,StopTime.ti_hund);
   fprintf(NAME,"Elapsed time : %2d:%02d:%02d.%02d\n",
       StopTime.ti_hour, StopTime.ti_min, StopTime.ti_sec,StopTime.ti_hund);
   fprintf (NAME,"\nSolution computed by natural Heuristic, Number of calls %lu\n",NumCalls);
   printf ("\nSolution computed by natural Heuristic, Number of calls %lu\n",NumCalls);
   PrintSolution(SolutionUCP);
   Release (SolutionUCP);
   Release(CM);
   fclose (NAME);
  }


for (Dominance=0;Dominance<2;Dominance++)
 for ( I=0;I<1;I++)
  {
   CM5=Duplicate(Cm);

   NAME=fopen ( OutputFile,"at");
   SolutionUCP=Init();
   uBound=MaxCost;
   NumCalls=0;
   printf ( "Solving by Compex Heuristic,dominance=%d \n",Dominance);
   fprintf (NAME, "Solving by Compex Heuristic,dominance=%d \n",Dominance);
   FindNumberOf1(CM5);
   gettime(&StartTime);
   ContribAddHeuristic ( CM5,SolutionUCP,Dominance );
   gettime(&StopTime);
   StopTime=RunTime(StartTime,StopTime);
   printf("Elapsed time : %2d:%02d:%02d.%02d\n",
       StopTime.ti_hour, StopTime.ti_min, StopTime.ti_sec,StopTime.ti_hund);
   fprintf(NAME,"Elapsed time : %2d:%02d:%02d.%02d\n",
       StopTime.ti_hour, StopTime.ti_min, StopTime.ti_sec,StopTime.ti_hund);
   fprintf (NAME,"\nSolution computed by Compex Heuristic, Number of calls %lu\n",NumCalls);
   printf ("\nSolution computed by Compex Heuristic, Number of calls %lu\n",NumCalls);
   PrintSolution(SolutionUCP);
   Release (SolutionUCP);
   Release(CM5);
   fclose(NAME);
}






   NAME=fopen ( OutputFile,"at");
   NumCalls=0;
   printf ( "Solwing by B&B with Limit Lower Bound computation\n");
   fprintf (NAME, "Solwing by B&B with Limit Lower Bound computation\n");
   SolutionUCP=Init();
   gettime(&StartTime);
   BABLLB ( CM2,SolutionUCP );
   gettime(&StopTime);
   StopTime=RunTime(StartTime,StopTime);

   printf("Elapsed time : %2d:%02d:%02d.%02d\n",
       StopTime.ti_hour, StopTime.ti_min, StopTime.ti_sec,StopTime.ti_hund);
   fprintf(NAME,"Elapsed time : %2d:%02d:%02d.%02d\n",
       StopTime.ti_hour, StopTime.ti_min, StopTime.ti_sec,StopTime.ti_hund);


   fprintf (NAME,"\nSolution computed by B&B with LLB, Number of calls B&B %lu\n",NumCalls);
   printf ("\nSolution computed by B&B with LLB, Number of calls B&B %lu\n",NumCalls);
   PrintSolution(SolutionUCP);
   Release (SolutionUCP);
   Release (CM2);
   fclose(NAME);



   NAME=fopen ( OutputFile,"at");
   printf ( "Solving by B&B with MSIR computation\n");
   fprintf (NAME, "Solving by B&B with MSIR computation\n");
   NumCalls=0;
   SolutionUCP=Init();
   uBound=MaxCost;
   gettime(&StartTime);
   BABMSIR ( CM3,SolutionUCP );
   gettime(&StopTime);
   StopTime=RunTime(StartTime,StopTime);
   printf("Elapsed time : %2d:%02d:%02d.%02d\n",
       StopTime.ti_hour, StopTime.ti_min, StopTime.ti_sec,StopTime.ti_hund);
   fprintf(NAME,"Elapsed time : %2d:%02d:%02d.%02d\n",
       StopTime.ti_hour, StopTime.ti_min, StopTime.ti_sec,StopTime.ti_hund);
   fprintf (NAME,"\nSolution computed by B&B with MSIR, Number of calls B&B %lu\n",NumCalls);
   printf ("\nSolution computed by B&B with MSIR, Number of calls B&B %lu\n",NumCalls);
   PrintSolution(SolutionUCP);
   Release (SolutionUCP);
   Release(CM3);
   fclose(NAME);




   NAME=fopen ( OutputFile,"at");
   SolutionUCP=Init();
   uBound=MaxCost;
   printf ( "Solving by B&B\n");
   fprintf (NAME, "Solving by B&B\n");
   NumCalls=0;
   gettime(&StartTime);
   BAB ( CM4,SolutionUCP );
   gettime(&StopTime);
   StopTime=RunTime(StartTime,StopTime);
   printf("Elapsed time : %2d:%02d:%02d.%02d\n",
       StopTime.ti_hour, StopTime.ti_min, StopTime.ti_sec,StopTime.ti_hund);
   fprintf(NAME,"Elapsed time : %2d:%02d:%02d.%02d\n",
       StopTime.ti_hour, StopTime.ti_min, StopTime.ti_sec,StopTime.ti_hund);
   fprintf (NAME,"\nSolution computed by B&B, Number of calls B&B %lu\n",NumCalls);
   printf ("\nSolution computed by B&B, Number of calls B&B %lu\n",NumCalls);
   PrintSolution(SolutionUCP);
   Release (SolutionUCP);
   Release(CM4);
   fclose(NAME);


   delete [] Cm->Mat;

}